/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 * 
 * @format
 */
'use strict';

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault")["default"];

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var invariant = require('invariant');

function weakObjectWrapper(resolverFn, key, isPlural) {
  return function () {
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    var data = resolverFn.apply(null, args);

    if (isPlural) {
      !Array.isArray(data) ? process.env.NODE_ENV !== "production" ? invariant(false, 'Resolver is expected to return a plural value.') : invariant(false) : void 0;
      return data.map(function (item) {
        return (0, _defineProperty2["default"])({}, key, item);
      });
    } else {
      return (0, _defineProperty2["default"])({}, key, data);
    }
  };
}

module.exports = weakObjectWrapper;